/******************************************************************************
** Az albbi program s informcik a Nemzeti Kutatsi Fejlesztsi Programok
** 2002. vi plyzatn a 2. sz. programban elfogadott NKFP-2/0017/2002 szm
** ,,Adatrosta - webtrhzak nagytmeg adatbzisainak elemzse adatbnyszati 
** s statisztikai eszkzk segtsgvel'' elnevezs projekt termke.
**
** A program a projekt folyamn feldolgozsra kerl naplllomnyok
** (web, access s mail) binris kdolst s tmrtst vgzi.
**
** A program s informcik az Adatrosta projekt konzorciumnak tulajdona.
** Engedly nlkli felhasznlsa tilos.
**
** Az Adatrosta projekt konzorcium tagjai:
** ELTE TTK Szmtgptudomnyi Tsz.
** BME Matematika Intzet
** MTA SZTAKI Informatikai Kutatlaboratrium
** Axelero Rt.
** econet.hu Rt.
**
** http://adatrosta.hu/
** email: info@adatrosta.hu
**
** (C) 2003. Minden jog fenntartva.
**
**
** This data and information are property of the "Data Riddle" consortium.
** Modification or use without permission is strictly prohibited.
**
** (C) 2003 All rights reserved.
**
** Author: RACZ Balazs, 2003.
**
******************************************************************************/

/*!
  \file   fourcc.cpp
  \brief  Library functions' implementation for fourcc handling

  \author RACZ Balazs
  \date   2003-01-27
*/

#include "lib/fourcc.h"
#include "lib/log.h"

static uint32 hexvalue(char ch) {
  if (('0'<=ch) &&(ch<='9')) {
    return ch-'0';
  } else if (('a'<=ch) &&(ch<='f')) {
    return 10+ch-'a';
  } else if (('A'<=ch) &&(ch<='F')) {
    return 10+ch-'A';
  } else return 16;
}

uint32 string2fourcc(string v){
  if (v[0]=='\'') { //string mode
    if (v.size()!=6) {
      warn(1,"Error parsing fourcc value %s: length != 6, like 'abcd'",v.c_str());
      return 0;
    }
    if (v[5]!='\'') {
      warn(1,"Error parsing fourcc value %s 6th char not single quote, like 'abcd'",v.c_str());
      return 0;
    }
    uint32 r;
    r=v[1];
    r<<=8;
    r|=v[2];
    r<<=8;
    r|=v[3];
    r<<=8;
    r|=v[4];
    return r;
  } else {
    if (v.size()!=8) {
      warn(1,"Error reading fourcc value >>%s<<: hex mode but not 8 digits, like 74206f8A",v.c_str());
      return 0;
    }
    uint32 r = 0,n;
    for(int i=0;i<8;i++) {
      r<<=4;
      n=hexvalue(v[i]);
      if (n>15) {
	warn(1,"Error reading fourcc value %s: hex mode but not hex digit: treated as 0.",v.c_str());
      } else r|=n;
    } // for digits
    return r;
  }
}


string fourcc2string(uint32 fourcc) {
  string r;
  //  int k;
  char *hexdigits = "0123456789abcdef";
  for (int i=0;i<8;i++) {
    r=hexdigits[fourcc&15] + r;
    fourcc>>=4;
  }
  return r;
}
